unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdTCPConnection, IdTCPClient, IdBaseComponent,
  IdComponent, IdTCPServer, ComCtrls, ExtCtrls, contnrs, syncobjs,
  IdThreadMgr, IdThreadMgrDefault, Menus;

const
  WM_DataAvailable = WM_User + 1;

type
  TUsers=class
  private
    FThreads:TObjectList;
    Fusers:TStringList;
    cs:TCriticalSection;
    function Getusername(index: TIdPeerThread): string;
    procedure Setusername(index: TIdPeerThread; const Value: string);
  public
    property UserNames[index:TIdPeerThread]:string read Getusername write Setusername; default;
    constructor create;
    destructor destroy; override;
    procedure add(t:TIdPeerThread);
    function delete(t:TIdPeerThread):string;
    procedure connected(t:TIdPeerThread; u:string);
    function find(u:string):TIdPeerThread;
  end;

  TForm1 = class(TForm)
    server: TIdTCPServer;
    client: TIdTCPClient;
    Button1: TButton;
    ListBox1: TListBox;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Button2: TButton;
    Edit2: TEdit;
    Edit3: TEdit;
    Button3: TButton;
    Button4: TButton;
    chat: TRichEdit;
    ColorBox1: TColorBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Label3: TLabel;
    IdThreadMgrDefault1: TIdThreadMgrDefault;
    PopupMenu1: TPopupMenu;
    Kick1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure serverExecute(AThread: TIdPeerThread);
    procedure Button3Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure clientDisconnected(Sender: TObject);
    procedure serverConnect(AThread: TIdPeerThread);
    procedure serverDisconnect(AThread: TIdPeerThread);
    procedure clientConnected(Sender: TObject);
    procedure Kick1Click(Sender: TObject);
  private
    u:TUsers;
    procedure processServerCommand(AThread: TIdPeerThread; cmd:string);
    procedure processServerMessageCommand(s:string);
    procedure processServerConnectCommand(AThread: TIdPeerThread; s:string);
    procedure serverMassCommand(cmd:string; notTo:TIdPeerThread=nil);
    procedure serverSendCommand(thread:TIdPeerThread; cmd:string);
    procedure processServerKickCommand(thread:TIdPeerThread; cmd:string);
    // client stuff
    procedure processClientCommand(cmd:string);
    procedure processClientMessageCommand(s:string);
    procedure clientSendCommand(cmd:string);
    procedure processClientConnectCommand(s:string);
    procedure processClientDisconnectCommand(s:string);
    procedure dataAvailable(var msg:TMessage); message WM_DataAvailable;
    procedure processClientErrorCommand(e:string);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  CRLF=#13#10;
  CMessage='message';
  CConnect='connect';
  CDisconnect='disconnect';
  CError='error';
  CKick='kick';

  CNotConnected='<not connected>';

type
  TDataAvailable=procedure(data:string) of object;
  
  TClientReader=class(TThread)
  private
    c:TIdTcpClient;
    FnotifyClient: hwnd;
  protected
    procedure execute; override;
  public
    constructor Create(ac:TIdTcpClient);
    property notifyClient:hwnd read FnotifyClient write FnotifyClient;
  end;

{ TClientReader }

constructor TClientReader.Create(ac: TIdTcpClient);
begin
  inherited create(true);
  freeonterminate:=true;
  c:=ac;
end;

procedure TClientReader.execute;
var s:string;
begin
  try
    while (not terminated) and (c.Connected) do
    begin
      s:=c.ReadLn(CRLF);
      if s<>'' then
        sendmessage(notifyclient, WM_DataAvailable, integer(pansichar(s)), 0);
    end;
  except
    on e:exception do
      if c.connected then
      begin
        c.disconnect;
        showmessage('Error while reading from sever: '+e.message);
      end;
  end;
end;

{ TUsers }

procedure TUsers.add(t: TIdPeerThread);
begin
  cs.Acquire;
  try
    fthreads.Add(t);
    Fusers.Add(CNotConnected);
  finally
    cs.Release;
  end;
end;

procedure TUsers.connected(t: TIdPeerThread; u: string);
var i:integer;
begin
  cs.Acquire;
  try
    i:=fthreads.IndexOf(t);
    if i>-1 then
      fusers[i]:=u;
  finally
    cs.Release;
  end;
end;

constructor TUsers.create;
begin
  FThreads:=TObjectList.create(false);
  FUsers:=TStringList.create;
  cs:=TCriticalSection.create;
end;

function TUsers.delete(t: TIdPeerThread):string;
var i:integer;
begin
  cs.Acquire;
  try
    i:=fthreads.IndexOf(t);
    if i>-1 then
    begin
      fthreads.Delete(i);
      result:=fusers[i];
      fusers.delete(i);
    end;
  finally
    cs.Release;
  end;
end;

destructor TUsers.destroy;
begin
  freeandnil(cs);
  freeandnil(fusers);
  freeandnil(fthreads);
  inherited;
end;

function TUsers.find(u: string): TIdPeerThread;
var i:integer;
begin
  cs.Acquire;
  try
    i:=0;
    while (i<fusers.count) and (not sametext(fusers[i], u)) do
      inc(i);
    if i<fusers.count then result:=TIdPeerThread(fthreads[i])
                      else result:=nil;
  finally
    cs.Release;
  end;
end;

function TUsers.Getusername(index: TIdPeerThread): string;
var i:integer;
begin
  cs.Acquire;
  try
    i:=fthreads.IndexOf(index);
    if i>-1 then
      result:=fusers[i];
  finally
    cs.Release;
  end;
end;

procedure TUsers.Setusername(index: TIdPeerThread; const Value: string);
var i:integer;
begin
  cs.Acquire;
  try
    i:=fthreads.IndexOf(index);
    if i>-1 then
      fusers[i]:=value;
  finally
    cs.Release;
  end;
end;

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  if server.Active then
    exit;
  button1.enabled:=false;
  u:=Tusers.create;
  server.Active:=true;
  sleep(1000);
  button2.click;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if client.Connected then
    exit;
  client.Host:=edit2.text;
  client.Connect;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  client.Disconnect;
end;

procedure TForm1.processClientMessageCommand(s: string);
var color:TColor;
    style:TFontStyle;
    i:integer;
begin
  i:=pos(#32, s);
  color:=TColor(strtoint(copy(s, 1, i-1)));
  delete(s, 1, i);
  assert(s[1]='[');
  chat.SelAttributes.Style:=[];
  delete(s,1,1);
  while s[1]<>']' do
  begin
    i:=pos(#32, s);
    if s[i-1]=']' then
      dec(i);
    style:=TFontStyle(strtoint(copy(s, 1, i-1)));
    chat.SelAttributes.Style:=chat.SelAttributes.Style+[style];
    delete(s, 1, i-1);
    if s[1]=']' then
      break     else
      delete(s,1,1);
  end;
  delete(s,1,2);
  chat.SelAttributes.Color:=color;
  chat.Lines.Add(s);
end;

procedure TForm1.processServerCommand(AThread: TIdPeerThread; cmd: string);
var i:integer;
    c,s:string;
begin
  i:=pos(#32, cmd);
  if i=0 then
  begin
    // process commands with no parameters. No such command implemented yet
  end    else
  begin
    c:=copy(cmd, 1, i-1);
    s:=copy(cmd, i+1, length(cmd));
    if sametext(c, CMessage) then
      processServerMessageCommand(s)
    else if sametext(c, CConnect) then
      processServerConnectCommand(AThread, s)
    else if sametext(c, CKick) then
      processServerKickCommand(AThread, s)
    else
      ;// ignore unkown command
  end;
end;

procedure TForm1.processServerConnectCommand(AThread: TIdPeerThread; s: string);
var l:TList;
    i:integer;
    un:string;
begin
  // right now, s is the username. maybe should validate for valid characters?
    if u.find(s)=nil then
    begin
      l:=server.Threads.LockList;
      try
        for i:=1 to l.count do
        begin
          un:=u[TIdPeerThread(l[i-1])];
          if un<>CNotConnected then
            serverSendCommand(athread, CConnect+' '+un);
        end;
      finally;
        server.Threads.UnlockList;
      end;
      u.connected(AThread, s);
      servermassCommand(CConnect+' '+s);
    end              else
    begin
      serverSendCommand(athread, CError+' that username is already connected.');
      athread.Connection.Disconnect;
    end;
end;

procedure TForm1.processServerMessageCommand(s: string);
begin
  serverMassCommand(CMessage+' '+s);
end;

procedure TForm1.serverExecute(AThread: TIdPeerThread);
var s:string;
begin
  s:=AThread.Connection.ReadLn(CRLF);
  if s<>'' then
    processServerCommand(AThread, s);
end;

procedure TForm1.serverMassCommand(cmd: string; notTo:TIdPeerThread);
var i:integer;
    c:TList;
begin
  c:=server.Threads.LockList;
  try
    for i:=1 to c.Count do
      if TIdPeerThread(c[i-1])<>notTo then
        serverSendCommand(TIdPeerThread(c[i-1]), cmd);
  finally
    server.Threads.UnlockList;
  end;
end;

procedure TForm1.serverSendCommand(thread: TIdPeerThread; cmd: string);
begin
  thread.Connection.Write(cmd+CRLF);
end;

procedure TForm1.Button3Click(Sender: TObject);
var cmd:string;
    s:string;
begin
  if trim(edit3.text)='' then
    exit;
  if not client.Connected then
    exit;
  s:='';
  if checkbox1.Checked then
    s:=s+' '+inttostr(integer(fsStrikeOut));
  if checkbox2.Checked then
    s:=s+' '+inttostr(integer(fsUnderline));
  if checkbox3.Checked then
    s:=s+' '+inttostr(integer(fsItalic));
  if checkbox4.Checked then
    s:=s+' '+inttostr(integer(fsBold));
  delete(s, 1, 1);
  cmd:=CMessage+' '+inttostr(integer(colorbox1.Selected))+' ['+s+'] '+edit3.text;
  clientSendCommand(cmd);
end;

procedure TForm1.clientSendCommand(cmd: string);
begin
  client.Write(cmd+CRLF);
end;

procedure TForm1.processClientCommand(cmd: string);
var i:integer;
    c,s:string;
begin
  i:=pos(#32, cmd);
  if i=0 then
  begin
    // process commands with no parameters. No such command implemented yet
  end    else
  begin
    c:=copy(cmd, 1, i-1);
    s:=copy(cmd, i+1, length(cmd));
    if sametext(c, CMessage) then
      processClientMessageCommand(s)
    else if sametext(c, CConnect) then
      processClientConnectCommand(s)
    else if sametext(c, CDisconnect) then
      processClientDisconnectCommand(s)
    else if sametext(c, CError) then
      processClientErrorCommand(s)
    else
      ;// ignore unkown command
  end;
end;

procedure TForm1.processClientConnectCommand(s: string);
begin
  listbox1.items.add(s);
end;

procedure TForm1.processClientDisconnectCommand(s: string);
var i:integer;
begin
  i:=listbox1.Items.IndexOf(s);
  if i>-1 then
    listbox1.Items.Delete(i);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if assigned(u) then
    freeandnil(u);
end;

procedure TForm1.clientDisconnected(Sender: TObject);
begin
  listbox1.clear;
  showmessage('disconnected');
end;

procedure TForm1.serverConnect(AThread: TIdPeerThread);
begin
  u.add(AThread);
end;

procedure TForm1.serverDisconnect(AThread: TIdPeerThread);
var s:string;
begin
  s:=u.delete(AThread);
  if trim(s)<>'' then
    serverMassCommand(CDisconnect+' '+s, AThread);
end;

procedure TForm1.clientConnected(Sender: TObject);
begin
  client.Write(CConnect+' '+edit1.text+CRLF);
  with TClientReader.Create(client) do
  begin
    notifyclient:=self.handle;
    resume;
  end;
end;

procedure TForm1.dataAvailable(var msg:TMessage);
var s:string;
begin
  s:=pansichar(pointer(msg.WParam));
  processClientCommand(s);    
end;

procedure TForm1.processClientErrorCommand(e: string);
begin
  messagedlg(e, mterror, [mbok], 0);
end;

procedure TForm1.Kick1Click(Sender: TObject);
begin
  if listbox1.ItemIndex=-1 then
    exit;
  clientSendCommand(CKick+' '+listbox1.items[listbox1.ItemIndex]);
end;

procedure TForm1.processServerKickCommand(thread: TIdPeerThread;
  cmd: string);
var t:TIdPeerThread;
begin
  // in our case, cmd is the username. we can extend this to also contain a reason.
  t:=u.find(cmd);
  if t<>nil then
  begin
    serverSendCommand(t, CError+' you have been kicked by '+u.UserNames[thread]);
    t.Connection.Disconnect;
  end;
end;

end.
